-- additional code revisions by Seryn
local T, IsIUP, scan_sector= ...

T.Events = {
	["HUD_SHOW"] = function(_, event, data)
		if (IsConnected() and T.tab_index == 1) then scan_sector() end
	end,
	
	["HUD_HIDE"] = function(_, event, data)
		if (IsConnected()) then T.refresh_timer:Kill() end
	end,
	
	["MSG_NOTIFICATION"] = function(_, event, msg)
		local name = msg:match("^You were attacked by (.*) in "..SystemNames[GetCurrentSystemid()])
		if (name) then
			local charID = GetCharacterIDByName(name)
			if (charID) then
				T.defenselist[charID] = os.time()
			end
			return
		end

		name = msg:match("^You attacked (.*) in "..SystemNames[GetCurrentSystemid()])
		if (name) then
			local charID = GetCharacterIDByName(name)
			if (charID) then
				T.aggressorlist[charID] = os.time()
			end
			return
		end
	end,

	["PLAYER_DIED"] = function(_, event, killed, killer)
		if (T.defenselist[killed] and GetPlayerName(killer) == GetPlayerName()) then
			T.defenselist[killed] = nil
		end

		if (T.aggressorlist[killer] and GetPlayerName(killed) == GetPlayerName()) then
			T.aggressorlist[killer] = nil
		end
	end,

	["PLAYER_ENTERED_GAME"] = function(_, event, data)
		if (not IsIUP(T.UI.display_container)) then -- don't attempt to recreate the display if they logged off previously
			T:BuildDisplay()
			T.hasmdi = false --isdeclared("mdi")
			if (T.hasmdi) then
		-- 			local contextmenu = {{
		-- 				title = function()
		-- 					if (T.pc_only) then return "Show NPCs" end
		-- 					return "Hide NPCs"
		-- 				end,
		-- 				action = togglepconly,
		-- 			}}
				mdi:CreateWindow(T.id, T.UI.display_container, {title = "Target List", cx = 350, cy = 350}) --, contextmenu)
			else
			end
			T.Events.TARGET_CHANGED()
		end
		if (not T.hasmdi) then end
		T:CreateRegions()
	end,
	
	["PLAYER_LEFT_SECTOR"] = function(_, event, charID)
		T.pinlist[charID] = nil
	end,

	["PLAYER_LOGGED_OUT"] = function(_, event, data)
		if (not T.hasmdi) then end
		T:DestroyRegions()
	end,
	
	["PLUGINS_LOADED"] = function(_, event, data)
		-- Because the tutorials recreate the HUD in different ways depending on the device
		-- initial display creation has been moved to PLAYER_ENTERED_GAME
		if (IsConnected()) then end
	end,
	
	["rHUDxscale"] = function(_, event, data)
		if (not IsConnected()) then return end
		T.refresh_timer:Kill()

		local timer = Timer()
		local function rHUDxscale_delayed_action()
			timer:SetTimeout(1, function()
				if (not T.hasmdi) then
					local r, err = pcall(T.RebuildDisplay, T)
					if (r) then
						ProcessEvent("TARGETLIST_TAB_CHANGED")
					else
						return rHUDxscale_delayed_action()
					end
				end
			end)
		end
		rHUDxscale_delayed_action()

	end,
	
	["SECTOR_CHANGED"] = function(_, sectorID)
		T.pinlist = {}
	end,

	["TARGET_CHANGED"] = function(_, event, select_only, i)
	-- Only Registered when the Targets tab is active
		if (targetlist.ScanLock()) then return end

		-- Based on selection mode, clear the highlight and get the current nodeid for re-highlighting
		if (select_only) then
			local select_listindex = T.tab_positions:GetItemPosition(T.tab_index, "select")
			if (select_listindex) then
				T.UI.display[select_listindex + T.list_offset]:SetHighlight("0 0 0 0")
				T.tab_positions:SetItemPosition(T.tab_index, "select", nil)
			end
			T.current_select_nodeid = T.tab_target_list[i]["nodeID"]

		else
			local target_listindex = T.tab_positions:GetItemPosition(T.tab_index, "active")
			if (target_listindex) then
				T.UI.display[target_listindex + T.list_offset]:SetHighlight("0 0 0 0")
				target_listindex = nil
			end
			T.current_target_nodeid = radar.GetRadarSelectionID()
		end

		-- find the listindex that matches the new selection/target and highlight it
		for i, v in ipairs(T.tab_target_list) do
			if (i > T.list_count) then break end

			if     (v["nodeID"] == T.current_target_nodeid) then
				T.UI.display[i + T.list_offset]:SetHighlight(T.current_target_color)
				T.tab_positions:SetItemPosition(T.tab_index, "active", i)
				if (not T.unlink_targeting) then break end

			elseif (v["nodeID"] == T.current_select_nodeid and T.current_select_nodeid ~= T.current_target_nodeid) then
				T.UI.display[i + T.list_offset]:SetHighlight(T.current_select_color)
				T.tab_positions:SetItemPosition(T.tab_index, "select", i)
			end
		end
	end,

	["UNLOAD_INTERFACE"] = function(_, event, data)
		T:DestroyRegions()
	end,

}

RegisterEvent(T.Events, "HUD_SHOW")
RegisterEvent(T.Events, "HUD_HIDE")
RegisterEvent(T.Events, "MSG_NOTIFICATION")
RegisterEvent(T.Events, "PLAYER_DIED")
RegisterEvent(T.Events, "PLAYER_ENTERED_GAME")
RegisterEvent(T.Events, "PLAYER_LEFT_SECTOR")
RegisterEvent(T.Events, "PLAYER_LOGGED_OUT")
RegisterEvent(T.Events, "PLUGINS_LOADED")
RegisterEvent(T.Events, "TARGET_CHANGED")
RegisterEvent(T.Events, "rHUDxscale")
RegisterEvent(T.Events, "SECTOR_CHANGED")
RegisterEvent(T.Events, "UNLOAD_INTERFACE")
